CON                              
                                 
  _clkmode = xtal1 + pll16x      
  _xinfreq = 5_000_000           
                                 
OBJ                              
                                 
'  pst   : "HyperTerminal - larry"       '"Parallax Serial Terminal"
  Menu  : "Menu - larry"
'  Tpe   : "Test Propeller Eeprom v0.677 - larry"
  eeprom  : "Propeller Eeprom - larry"                   ' Propeller EEPROM object 

VAR
    byte Y[5], index, othervar
    word  StartAddr
    long value[32], start, end, eeaddr, count, size 
  
PUB Add_value


   Menu.Init                  'Menu simplifies the calls to HyperTerminal
   
   repeat 4   
     Save_wear(7)
     
   start := Y
   count := index
   size := 1
   Wryte(start, count, size)
'   Menu.DisplayElement(Y, index)      

   
{{  pst.Str(String("Eeprom trials: "))           'do not call hyperterminal! call menu
  pst.Cr
  pst.dec (Y[0])
  pst.Cr   
  pst.dec(index)
  SendIt                  }}


PUB Save_Wear(x)

    index := 0                    'index must be initialized to 0

    repeat while Y[index] 
      index++  
    If index > 5
      bytefill(@Y, 0, 5)
      Save_wear(x)'       
    Y[index] := (x)
    
'    Menu.TryAgain      
'    Wryte(start, count, size)
         
'    SendIt
'    Menu.GetLimits(index)       change to match parameter list
PUB SendIt

  StartAddr := index
  count    := 1                               'parameters must be passed
  size     := 1
                                                             
{{PUB Write | i, temp                              '' Write individual values to EEPROM
                                                 ''
  '' Prompts user for EEPROM starting address, number of values to be entered and variable
  '' size.  Then, prompts user for values to store.  Each value gets stored in EEPROM
  '' locations building from the start address entered by teh user to smaller addresses.  
                                                 
  menu.EeParams(@eeAddr, @count, @size)
  repeat i from eeAddr - size + 1 to eeAddr - (count * size) + 1 step size
    temp := menu.getElement(i)
    eeprom.FromRam(@temp.byte[0], @temp.byte[size-1], i)        
'  Read
'  Menu.KeyPress
                                                           }}
PUB Wryte(addr, cownt, syze) | i, temp
     
'   Menu.DisplayElement(Y, index + 1)   
   repeat i from addr - syze + 1 to addr - (cownt * syze) + 1 step syze
     temp := Y[i]
'Menu.DisplayElement(Y, index)
     Menu.DisplayElement(Y,start)
     Menu.DisplayElement(Y,count)
     Menu.DisplayElement(Y,size)     
     eeprom.FromRam(@temp.byte[0], @temp.byte[syze-1], i)   'executes once only! changed FROM byte[0]
     Menu.DisplayElement(Y, index + 6)
'   Menu.TryAgain                                                                             

   
{{PUB Read | i, temp                               '' Read individual values from EEPROM
                                                 ''
  '' Prompts user for EEPROM starting address, number of values to be retrieved and
  '' variable size.  Retrieves and displays values stored in EEPROM locations
  '' building from the start address entered by the user to smaller addresses.  

  temp~
  menu.EeParams(@eeAddr, @count, @size)
  repeat i from eeAddr - size + 1 to eeAddr - (count * size) + 1 step size
    eeprom.ToRam(@temp.byte[0], @temp.byte[size - 1], i)
    menu.DisplayElement(temp, i)                              }}

{{PUB EraseIt

    index := 0

    repeat index from 0 to 4
      BS2.Write_CodeMem(@Y + index, Y, 1)  }}
         